View Javadoc

    1   /*
    2    *  Licensed to the Apache Software Foundation (ASF) under one
    3    *  or more contributor license agreements.  See the NOTICE file
    4    *  distributed with this work for additional information
    5    *  regarding copyright ownership.  The ASF licenses this file
    6    *  to you under the Apache License, Version 2.0 (the
    7    *  "License"); you may not use this file except in compliance
    8    *  with the License.  You may obtain a copy of the License at
    9    *
    10   *    http://www.apache.org/licenses/LICENSE-2.0
    11   *
    12   *  Unless required by applicable law or agreed to in writing,
    13   *  software distributed under the License is distributed on an
    14   *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    15   *  KIND, either express or implied.  See the License for the
    16   *  specific language governing permissions and limitations
    17   *  under the License.
    18   *
    19   */
    20  package org.apache.mina.filter.codec.statemachine;
    21
    22  import org.apache.mina.core.buffer.IoBuffer;
    23  import org.apache.mina.filter.codec.ProtocolDecoderException;
    24  import org.apache.mina.filter.codec.ProtocolDecoderOutput;
    25
    26  /**
    27   * {@link DecodingState} which decodes <code>int</code> values in big-endian
    28   * order (high bytes come first).
    29   *
    30   * @author <a href="http://mina.apache.org">Apache MINA Project</a>
    31   */
    32  public abstract class IntegerDecodingState implements DecodingState {
    33
    34      private int firstByte;
    35
    36      private int secondByte;
    37
    38      private int thirdByte;
    39
    40      private int counter;
    41
    42      /**
    43       * {@inheritDoc}
    44       */
    45      public DecodingState decode(IoBuffer in, ProtocolDecoderOutput out) throws Exception {
    46          while (in.hasRemaining()) {
    47              switch (counter) {
    48              case 0:
    49                  firstByte = in.getUnsigned();
    50                  break;
    51              case 1:
    52                  secondByte = in.getUnsigned();
    53                  break;
    54              case 2:
    55                  thirdByte = in.getUnsigned();
    56                  break;
    57              case 3:
    58                  counter = 0;
    59                  return finishDecode((firstByte << 24) | (secondByte << 16) | (thirdByte << 8) | in.getUnsigned(), out);
    60              default:
    61                  throw new InternalError();
    62              }
    63              counter++;
    64          }
    65
    66          return this;
    67      }
    68
    69      /**
    70       * {@inheritDoc}
    71       */
    72      public DecodingState finishDecode(ProtocolDecoderOutput out) throws Exception {
    73          throw new ProtocolDecoderException("Unexpected end of session while waiting for an integer.");
    74      }
    75
    76      /**
    77       * Invoked when this state has consumed a complete <code>int</code>.
    78       *
    79       * @param value the integer.
    80       * @param out the current {@link ProtocolDecoderOutput} used to write
    81       *        decoded messages.
    82       * @return the next state if a state transition was triggered (use
    83       *         <code>this</code> for loop transitions) or <code>null</code> if
    84       *         the state machine has reached its end.
    85       * @throws Exception if the read data violated protocol specification.
    86       */
    87      protected abstract DecodingState finishDecode(int value, ProtocolDecoderOutput out) throws Exception;
    88  }